## orthanc-neuro 1.0

=== CMakeLists.txt ===
# Neuroimaging plugin for Orthanc
# Copyright (C) 2021-2022 Sebastien Jodogne, UCLouvain, Belgium
#
# This program is free software: you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.


cmake_minimum_required(VERSION 2.8)

project(OrthancNeuro)

set(ORTHANC_PLUGIN_VERSION "1.0")

if (ORTHANC_PLUGIN_VERSION STREQUAL "mainline")
  set(ORTHANC_FRAMEWORK_DEFAULT_VERSION "mainline")
  set(ORTHANC_FRAMEWORK_DEFAULT_SOURCE "hg")
else()
  set(ORTHANC_FRAMEWORK_DEFAULT_VERSION "1.10.1")
  set(ORTHANC_FRAMEWORK_DEFAULT_SOURCE "web")
endif()


# Parameters of the build
set(STATIC_BUILD OFF CACHE BOOL "Static build of the third-party libraries (necessary for Windows)")
set(ALLOW_DOWNLOADS OFF CACHE BOOL "Allow CMake to download packages")
set(ORTHANC_FRAMEWORK_SOURCE "${ORTHANC_FRAMEWORK_DEFAULT_SOURCE}" CACHE STRING "Source of the Orthanc framework (can be \"system\", \"hg\", \"archive\", \"web\" or \"path\")")
set(ORTHANC_FRAMEWORK_VERSION "${ORTHANC_FRAMEWORK_DEFAULT_VERSION}" CACHE STRING "Version of the Orthanc framework")
set(ORTHANC_FRAMEWORK_ARCHIVE "" CACHE STRING "Path to the Orthanc archive, if ORTHANC_FRAMEWORK_SOURCE is \"archive\"")
set(ORTHANC_FRAMEWORK_ROOT "" CACHE STRING "Path to the Orthanc source directory, if ORTHANC_FRAMEWORK_SOURCE is \"path\"")

set(USE_SYSTEM_NIFTILIB ON CACHE BOOL "Use the system version of niftilib")


# Advanced parameters to fine-tune linking against system libraries
set(USE_SYSTEM_ORTHANC_SDK ON CACHE BOOL "Use the system version of the Orthanc plugin SDK")
set(ORTHANC_FRAMEWORK_STATIC OFF CACHE BOOL "If linking against the Orthanc framework system library, indicates whether this library was statically linked")
mark_as_advanced(ORTHANC_FRAMEWORK_STATIC)


# Download and setup the Orthanc framework
include(${CMAKE_SOURCE_DIR}/Resources/Orthanc/CMake/DownloadOrthancFramework.cmake)

if (ORTHANC_FRAMEWORK_SOURCE STREQUAL "system")
  if (ORTHANC_FRAMEWORK_USE_SHARED)
    include(FindBoost)
    find_package(Boost COMPONENTS filesystem thread)
    
    if (NOT Boost_FOUND)
      message(FATAL_ERROR "Unable to locate Boost on this system")
    endif()
    
    include(FindDCMTK)
    link_libraries(${Boost_LIBRARIES} ${DCMTK_LIBRARIES} jsoncpp)
  endif()

  link_libraries(${ORTHANC_FRAMEWORK_LIBRARIES})
  
  set(USE_SYSTEM_GOOGLE_TEST ON CACHE BOOL "Use the system version of Google Test")
  set(USE_GOOGLE_TEST_DEBIAN_PACKAGE OFF CACHE BOOL "Use the sources of Google Test shipped with libgtest-dev (Debian only)")
  mark_as_advanced(USE_GOOGLE_TEST_DEBIAN_PACKAGE)
  include(${CMAKE_SOURCE_DIR}/Resources/Orthanc/CMake/GoogleTestConfiguration.cmake)

else()
  include(${ORTHANC_FRAMEWORK_ROOT}/../Resources/CMake/OrthancFrameworkParameters.cmake)
  
  set(ENABLE_GOOGLE_TEST ON)
  set(ENABLE_ZLIB ON)

  set(ENABLE_DCMTK OFF)   # Could be set to "ON" for debugging
  set(ENABLE_PNG OFF)     # Could be set to "ON" for debugging
  set(ENABLE_LOCALE OFF)  # Disable support for locales (notably in Boost)
  set(ENABLE_MODULE_JOBS OFF CACHE INTERNAL "")

  include(${ORTHANC_FRAMEWORK_ROOT}/../Resources/CMake/OrthancFrameworkConfiguration.cmake)
  include_directories(${ORTHANC_FRAMEWORK_ROOT})
endif()


include(${CMAKE_SOURCE_DIR}/Resources/CMake/NiftiCLib.cmake)
include(${CMAKE_SOURCE_DIR}/Resources/Orthanc/Plugins/OrthancPluginsExports.cmake)


# Check that the Orthanc SDK headers are available
if (STATIC_BUILD OR NOT USE_SYSTEM_ORTHANC_SDK)
  include_directories(${CMAKE_SOURCE_DIR}/Resources/Orthanc/Sdk-1.10.1)
else ()
  CHECK_INCLUDE_FILE_CXX(orthanc/OrthancCPlugin.h HAVE_ORTHANC_H)
  if (NOT HAVE_ORTHANC_H)
    message(FATAL_ERROR "Please install the headers of the Orthanc plugins SDK")
  endif()
endif()


add_definitions(
  -DHAS_ORTHANC_EXCEPTION=1
  -DORTHANC_PLUGIN_VERSION="${ORTHANC_PLUGIN_VERSION}"
  )

EmbedResources(
  ORTHANC_EXPLORER  ${CMAKE_SOURCE_DIR}/Sources/Plugin/OrthancExplorer.js
  )

if (${CMAKE_SYSTEM_NAME} STREQUAL "Linux" OR
    ${CMAKE_SYSTEM_NAME} STREQUAL "kFreeBSD" OR
    ${CMAKE_SYSTEM_NAME} STREQUAL "FreeBSD")
  link_libraries(rt)
elseif (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")
  execute_process(
    COMMAND 
    ${PYTHON_EXECUTABLE} ${CMAKE_SOURCE_DIR}/Resources/Orthanc/CMake/WindowsResources.py
    ${ORTHANC_PLUGIN_VERSION} "OrthancNeuro" OrthancNeuro.dll ""
    ERROR_VARIABLE Failure
    OUTPUT_FILE ${AUTOGENERATED_DIR}/Version.rc
    )

  if (Failure)
    message(FATAL_ERROR "Error while computing the version information: ${Failure}")
  endif()

  list(APPEND AUTOGENERATED_SOURCES  ${AUTOGENERATED_DIR}/Version.rc)
endif()


set(NEURO_SOURCES
  Sources/Framework/BufferReader.cpp
  Sources/Framework/CSAHeader.cpp
  Sources/Framework/CSATag.cpp
  Sources/Framework/DicomInstancesCollection.cpp
  Sources/Framework/IDicomFrameDecoder.cpp
  Sources/Framework/InputDicomInstance.cpp
  Sources/Framework/NeuroToolbox.cpp
  Sources/Framework/NiftiWriter.cpp
  Sources/Framework/Slice.cpp
  
  ${NIFTILIB_SOURCES}
  ${AUTOGENERATED_SOURCES}
  ${ORTHANC_CORE_SOURCES}
  )


add_custom_target(
  AutogeneratedTarget
  DEPENDS 
  ${AUTOGENERATED_SOURCES}
  )
          
add_library(OrthancNeuro SHARED
  Sources/Plugin/Plugin.cpp
  Sources/Plugin/PluginFrameDecoder.cpp

  ${NEURO_SOURCES}
  ${CMAKE_SOURCE_DIR}/Resources/Orthanc/Plugins/OrthancPluginCppWrapper.cpp
  )

add_dependencies(OrthancNeuro AutogeneratedTarget)

add_executable(UnitTests
  Sources/UnitTestsSources/NiftiTests.cpp
  Sources/UnitTestsSources/UnitTestsMain.cpp

  ${NEURO_SOURCES}
  ${GOOGLE_TEST_SOURCES}
  )

add_dependencies(UnitTests AutogeneratedTarget)

target_link_libraries(UnitTests ${GOOGLE_TEST_LIBRARIES})


message("Setting the version of the library to ${ORTHANC_PLUGIN_VERSION}")

set_target_properties(OrthancNeuro PROPERTIES 
  VERSION ${ORTHANC_PLUGIN_VERSION} 
  SOVERSION ${ORTHANC_PLUGIN_VERSION})

install(
  TARGETS OrthancNeuro
  RUNTIME DESTINATION lib    # Destination for Windows
  LIBRARY DESTINATION share/orthanc/plugins    # Destination for Linux
  )

=== debian/changelog ===
orthanc-neuro (1.0-2build4) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 18:12:05 +1100

orthanc-neuro (1.0-2build3) noble; urgency=medium

  * No-change rebuild against libpng1.6 t64.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 17 Mar 2024 18:30:01 +0100

orthanc-neuro (1.0-2build2) noble; urgency=medium

  * No-change rebuild against libpng16-16t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 29 Feb 2024 07:47:09 +0000

orthanc-neuro (1.0-2build1) noble; urgency=medium

  * No-change rebuild for boost defaults change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 19 Dec 2023 20:44:35 +0100

orthanc-neuro (1.0-2) unstable; urgency=medium

  * Team upload.

  [ Komolehin Israel Timilehin ]
  * Added autopkgtest

  [ Andreas Tille ]
  * Standards-Version: 4.6.2 (routine-update)

 -- Komolehin Israel Timilehin <komolehinisrael@gmail.com>  Wed, 25 Oct 2023 11:46:38 +0000

orthanc-neuro (1.0-1) unstable; urgency=low

  * Initial release. (Closes: #1010210)

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Wed, 27 Apr 2022 21:48:19 +0200

=== debian/control ===
Source: orthanc-neuro
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Sebastien Jodogne <s.jodogne@gmail.com>
Section: science
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 13),
               libgtest-dev,
               libnifti-dev,
               liborthancframework-dev,
               orthanc-dev (>= 1.10.1),
               unzip,
               uuid-dev
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/med-team/orthanc-neuro
Vcs-Git: https://salsa.debian.org/med-team/orthanc-neuro.git
Homepage: https://book.orthanc-server.com/plugins/neuro.html
Rules-Requires-Root: no

Package: orthanc-neuro
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
         orthanc
Built-Using: ${orthancframework:Built-Using}
Description: Neuroimaging plugin for Orthanc
 This package installs a plugin for Orthanc, the lightweight, RESTful
 Vendor Neutral Archive for medical imaging. This plugin adds support
 for neuroimaging in Orthanc, notably to easily convert from DICOM to
 NIfTI.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

export UPSTREAM_VERSION := $(shell echo "$(DEB_VERSION)" | cut -d '-' -f 1)
export TARGET := libOrthancNeuro.so

export DEB_BUILD_MAINT_OPTIONS := hardening=+all

# Disable assert() checking from upstream project, for best performance
# https://lists.debian.org/debian-med/2018/04/msg00132.html
export DEB_CFLAGS_MAINT_APPEND=-DNDEBUG
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ --builddirectory=Build

CMAKE_EXTRA_FLAGS += \
	-DCMAKE_SKIP_RPATH:BOOL=ON \
	-DSTATIC_BUILD:BOOL=OFF \
	-DORTHANC_FRAMEWORK_SOURCE=system \
	-DUSE_GOOGLE_TEST_DEBIAN_PACKAGE:BOOL=ON \
	-DORTHANC_FRAMEWORK_USE_SHARED:BOOL=OFF \
	"-DORTHANC_FRAMEWORK_ADDITIONAL_LIBRARIES=dcmdata dcmjpls dcmimage dcmjpeg ofstd boost_filesystem boost_iostreams boost_locale boost_regex boost_thread pugixml uuid jsoncpp png jpeg z" \
	-DCMAKE_BUILD_TYPE=None  # The build type must be set to None, see #711515


# Automated generation of the "Built-Using" attribute in "d/control"
# https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=989128
# Adapted from:
# https://wiki.debian.org/SIMDEverywhere#Approach (Point 6)
override_dh_gencontrol:
	dh_gencontrol -- -Vorthancframework:Built-Using="$(shell dpkg-query -f '$${source:Package} (= $${source:Version}), ' -W liborthancframework-dev)"

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_EXTRA_FLAGS)

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	( cd Build; ./UnitTests )
endif

override_dh_auto_install:
	dh_install Build/${TARGET}.${UPSTREAM_VERSION} usr/lib/orthanc

override_dh_link:
	dh_link usr/lib/orthanc/${TARGET}.${UPSTREAM_VERSION} usr/share/orthanc/plugins/${TARGET}

override_dh_installchangelogs:
	dh_installchangelogs -k NEWS

=== debian/watch ===
version=4
opts="downloadurlmangle=s/\/browse\.php\?path=//g,repack,compression=xz" \
https://www.orthanc-server.com/browse.php?path=/plugin-neuro downloads/get\.php\?path=/plugin-neuro/OrthancNeuro-(\d\S*)\.tar\.gz

## orthanc-neuro 1.1%2Bdfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 # Neuroimaging plugin for Orthanc
-# Copyright (C) 2021-2022 Sebastien Jodogne, UCLouvain, Belgium
+# Copyright (C) 2021-2024 Sebastien Jodogne, ICTEAM UCLouvain, Belgium
 #
 # This program is free software: you can redistribute it and/or
 # modify it under the terms of the GNU General Public License as
@@ -19,13 +19,13 @@
 
 project(OrthancNeuro)
 
-set(ORTHANC_PLUGIN_VERSION "1.0")
+set(ORTHANC_PLUGIN_VERSION "1.1")
 
 if (ORTHANC_PLUGIN_VERSION STREQUAL "mainline")
   set(ORTHANC_FRAMEWORK_DEFAULT_VERSION "mainline")
   set(ORTHANC_FRAMEWORK_DEFAULT_SOURCE "hg")
 else()
-  set(ORTHANC_FRAMEWORK_DEFAULT_VERSION "1.10.1")
+  set(ORTHANC_FRAMEWORK_DEFAULT_VERSION "1.12.3")
   set(ORTHANC_FRAMEWORK_DEFAULT_SOURCE "web")
 endif()
 
@@ -76,9 +76,17 @@
   set(ENABLE_GOOGLE_TEST ON)
   set(ENABLE_ZLIB ON)
 
-  set(ENABLE_DCMTK OFF)   # Could be set to "ON" for debugging
-  set(ENABLE_PNG OFF)     # Could be set to "ON" for debugging
-  set(ENABLE_LOCALE OFF)  # Disable support for locales (notably in Boost)
+  if (OFF)
+    # Enable DCMTK for testing on raw DICOM files
+    set(ENABLE_DCMTK ON)
+    set(ENABLE_PNG ON)
+    set(ENABLE_LOCALE ON)
+  else()
+    set(ENABLE_DCMTK OFF)
+    set(ENABLE_PNG OFF)
+    set(ENABLE_LOCALE OFF)
+  endif()
+   
   set(ENABLE_MODULE_JOBS OFF CACHE INTERNAL "")
 
   include(${ORTHANC_FRAMEWORK_ROOT}/../Resources/CMake/OrthancFrameworkConfiguration.cmake)
@@ -117,8 +125,8 @@
 elseif (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")
   execute_process(
     COMMAND 
-    ${PYTHON_EXECUTABLE} ${CMAKE_SOURCE_DIR}/Resources/Orthanc/CMake/WindowsResources.py
-    ${ORTHANC_PLUGIN_VERSION} "OrthancNeuro" OrthancNeuro.dll ""
+    ${PYTHON_EXECUTABLE} ${ORTHANC_FRAMEWORK_ROOT}/../Resources/WindowsResources.py
+    ${ORTHANC_PLUGIN_VERSION} "Neuroimaging plugin" OrthancNeuro.dll "Neuroimaging plugin for Orthanc"
     ERROR_VARIABLE Failure
     OUTPUT_FILE ${AUTOGENERATED_DIR}/Version.rc
     )
@@ -147,6 +155,11 @@
   ${ORTHANC_CORE_SOURCES}
   )
 
+if (ENABLE_DCMTK)
+  link_libraries(${DCMTK_LIBRARIES})
+  list(APPEND NEURO_SOURCES ${ORTHANC_DICOM_SOURCES})
+endif()
+
 
 add_custom_target(
   AutogeneratedTarget
@@ -188,3 +201,8 @@
   RUNTIME DESTINATION lib    # Destination for Windows
   LIBRARY DESTINATION share/orthanc/plugins    # Destination for Linux
   )
+
+if (COMMAND DefineSourceBasenameForTarget)
+  DefineSourceBasenameForTarget(OrthancNeuro)
+  DefineSourceBasenameForTarget(UnitTests)
+endif()

=== debian/changelog ===
orthanc-neuro (1.1+dfsg-1ubuntu4) plucky; urgency=medium

  * No-change rebuild for libdcmtk19.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Wed, 26 Feb 2025 14:50:03 +0000

orthanc-neuro (1.1+dfsg-1ubuntu3) plucky; urgency=medium

  * No-change rebuild for libjsoncpp26

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sun, 10 Nov 2024 11:00:00 +0000

orthanc-neuro (1.1+dfsg-1ubuntu2) oracular; urgency=medium

  * Revert last upload, back in sync with Debian (orthanc fixed instead)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 08 Jul 2024 10:28:56 +0200

orthanc-neuro (1.1+dfsg-1build1) oracular; urgency=medium

  * Rebuild against new libdcmtk18.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 08 Jul 2024 09:38:08 +0200

orthanc-neuro (1.1+dfsg-1) unstable; urgency=medium

  * New upstream version.

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Fri, 29 Mar 2024 13:05:55 +0100

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: orthanc-neuro
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
+Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Sebastien Jodogne <s.jodogne@gmail.com>
 Section: science
 Priority: optional

## orthanc-neuro 1.1+dfsg

=== debian/changelog ===
orthanc-neuro (1.1+dfsg-2) unstable; urgency=medium

  * Fix FTBFS with recent versions of CMake. Closes: #1113374

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Mon, 01 Sep 2025 12:34:30 +0200

=== debian/control ===
--- 
+++ 
@@ -11,10 +11,10 @@
                orthanc-dev (>= 1.10.1),
                unzip,
                uuid-dev
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/med-team/orthanc-neuro
 Vcs-Git: https://salsa.debian.org/med-team/orthanc-neuro.git
-Homepage: https://book.orthanc-server.com/plugins/neuro.html
+Homepage: https://orthanc.uclouvain.be/book/plugins/neuro.html
 Rules-Requires-Root: no
 
 Package: orthanc-neuro

=== debian/rules ===
--- 
+++ 
@@ -2,7 +2,7 @@
 
 include /usr/share/dpkg/pkg-info.mk
 
-export UPSTREAM_VERSION := $(shell echo "$(DEB_VERSION)" | cut -d '-' -f 1)
+export UPSTREAM_VERSION := $(shell echo "$(DEB_VERSION)" | cut -d '+' -f 1)
 export TARGET := libOrthancNeuro.so
 
 export DEB_BUILD_MAINT_OPTIONS := hardening=+all

=== debian/tests/control ===
Tests: run-unit-test
Restrictions: allow-stderr
Depends: @,
        build-essential,
        cmake,
        debhelper-compat (= 13),
        libgtest-dev,
        libnifti-dev,
        liborthancframework-dev,
        orthanc-dev (>= 1.10.1),
        unzip,
        uuid-dev

=== debian/watch ===
version=4
opts="repacksuffix=+dfsg,dversionmangle=s/\+dfsg//g,repack,compression=xz" \
https://orthanc.uclouvain.be/downloads/sources/orthanc-neuro/index.html OrthancNeuro-(\d\S*)\.tar\.gz
